## creduce 2.8.0~20180311

=== CMakeLists.txt ===
## -*- mode: CMake -*-
##
## Copyright (c) 2012, 2013, 2014, 2015, 2016, 2017 The University of Utah
## All rights reserved.
##
## This file is distributed under the University of Illinois Open Source
## License.  See the file COPYING for details.

###############################################################################

cmake_minimum_required(VERSION 2.8.12)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

include(CheckIncludeFile)
include(CheckCXXCompilerFlag)
include(GetGitRevisionDescription)

project(creduce)

###############################################################################

# Locate LLVM and check its version.  Do this here because we need the LLVM
# package definitions in the "CMakeLists.txt" files for multiple subdirs.
#
find_package(LLVM REQUIRED CONFIG NO_CMAKE_BUILDS_PATH)
message(STATUS "Found LLVM ${LLVM_PACKAGE_VERSION}")
message(STATUS "Using LLVMConfig.cmake in ${LLVM_DIR}")
if (${LLVM_PACKAGE_VERSION} VERSION_LESS "4.0")
  message(FATAL_ERROR "C-Reduce requires LLVM 4.0 or later")
endif()
#
# Do this here, too, just to keep it with the LLVM check above.
#
find_package(Clang REQUIRED CONFIG NO_CMAKE_BUILDS_PATH)
message(STATUS "Using ClangConfig.cmake in ${Clang_DIR}")

# Locate Perl and check its version.
#
include(FindPerl)
if(${PERL_VERSION_STRING} VERSION_LESS "5.10.0")
  message(FATAL_ERROR "C-Reduce requires Perl 5.10.0 or later")
endif()

# Locate flex.  Do this here because we need the package definitions in the
# "CMakeLists.txt" files for multiple subdirs.
#
find_package(FLEX)

###############################################################################

# Determine the short git hash for the source tree.  The logic here follows the
# logic in the `git-hash.sh` script.
#
## METHOD 1: The source tree is the result of `git archive'.
# `git archive' inserts the abbreviated hash of the archive's commit into this
# file.  (See the `.gitattributes' file.)
#
set(GIT_HASH "$Format:%h$")
if(GIT_HASH MATCHES "^\\$")
  ## METHOD 2: The source tree is a git repository.
  get_git_head_revision(GIT_REFSPEC GIT_HASH)
  if(NOT GIT_HASH STREQUAL "GITDIR-NOTFOUND")
    # Trim to the short hash.
    string(SUBSTRING "${GIT_HASH}" 0 7 GIT_HASH)
  else()
    ## METHOD 3: Give up.
    set(GIT_HASH "unknown")
  endif()
endif()

###############################################################################

# Generate the "config.h" file.
#
set(ENABLE_TRANS_ASSERT ON CACHE BOOL
  "Use assert() in clang_delta transformations.")

check_include_file("dlfcn.h"		HAVE_DLFCN_H)
check_include_file("inttypes.h"		HAVE_INTTYPES_H)
check_include_file("memory.h"		HAVE_MEMORY_H)
check_include_file("stdint.h"		HAVE_STDINT_H)
check_include_file("stdlib.h"		HAVE_STDLIB_H)
check_include_file("strings.h"		HAVE_STRINGS_H)
check_include_file("string.h"		HAVE_STRING_H)
check_include_file("sys/stat.h"		HAVE_SYS_STAT_H)
check_include_file("sys/types.h"	HAVE_SYS_TYPES_H)
check_include_file("unistd.h"		HAVE_UNISTD_H)

set(creduce_PACKAGE			"creduce")
set(creduce_PACKAGE_BUGREPORT		"creduce-bugs@flux.utah.edu")
set(creduce_PACKAGE_NAME		"creduce")
set(creduce_PACKAGE_STRING		"creduce 2.8.0")
set(creduce_PACKAGE_TARNAME		"creduce")
set(creduce_PACKAGE_URL			"http://embed.cs.utah.edu/creduce/")
set(creduce_PACKAGE_VERSION		"2.8.0")
set(creduce_VERSION			"2.8.0")

# FIXME: Should be determined automatically.
set(YYTEXT_POINTER 1)

configure_file("cmake_config.h.in" "${PROJECT_BINARY_DIR}/config.h")
add_definitions("-DHAVE_CONFIG_H")

###############################################################################

# Use option `-fvisibility-inlines-hidden` if the C++ compiler supports it.
# See LLVM file `share/llvm/cmake/HandleLLVMOptions.cmake`.
#
check_cxx_compiler_flag(
  "-fvisibility-inlines-hidden"
  SUPPORTS_FVISIBILITY_INLINES_HIDDEN_FLAG
  )

if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU"
    OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
  # XXX figure out how to get "-std=c++11 -fno-rtti" from LLVM.  That's how we
  # get those options in the Automake path...
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -fno-rtti -fno-strict-aliasing -Wall -Wextra -Wno-long-long -Wno-unused-parameter -Wno-missing-field-initializers")
  if(SUPPORTS_FVISIBILITY_INLINES_HIDDEN_FLAG)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility-inlines-hidden")
  endif()
  set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3")
endif()

###############################################################################

add_subdirectory(clang_delta)
add_subdirectory(clex)
add_subdirectory(creduce)
add_subdirectory(delta)
# `unifdef' requires a Unix-y platform.
if(UNIX)
  add_subdirectory(unifdef)
else()
  message(WARNING
    "Internal tool `unifdef${CMAKE_EXECUTABLE_SUFFIX}' cannot be compiled on this OS; skipping.")
endif()

###############################################################################

## End of file.

=== clang_delta/CMakeLists.txt ===
## -*- mode: CMake -*-
##
## Copyright (c) 2012, 2013, 2014, 2015, 2016, 2017 The University of Utah
## All rights reserved.
##
## This file is distributed under the University of Illinois Open Source
## License.  See the file COPYING for details.

###############################################################################

cmake_minimum_required(VERSION 2.8.12)
project(clang_delta)

###############################################################################

# find_package(LLVM) is done by the topmost "CMakeLists.txt" file.
# find_package(Clang) is done by the topmost "CMakeLists.txt" file.

# Generate file "git_version.cpp".
#
configure_file("git_version.cpp.in" "git_version.cpp" @ONLY)

# set values for replacing variables in lit.site.cfg.in
#
set(LLVM_BINDIR ${LLVM_TOOLS_BINARY_DIR})
set(abs_builddir ${CMAKE_CURRENT_BINARY_DIR})
set(clang_delta_srcdir ${CMAKE_CURRENT_SOURCE_DIR})

# Generate file "lit.site.cfg".
#
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/tests/lit.site.cfg.in
  ${CMAKE_CURRENT_BINARY_DIR}/tests/lit.site.cfg @ONLY)

# Generate file "remove_lit_checks.pl", which is necessary for removing
# "lit-functioning" lines such as "CHECK:" and "RUN:" from test output.
#
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/tests/remove_lit_checks.in
  ${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/remove_lit_checks @ONLY)
file(COPY ${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/remove_lit_checks
  DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/tests
  FILE_PERMISSIONS
    OWNER_READ OWNER_WRITE OWNER_EXECUTE
    GROUP_READ GROUP_EXECUTE
    WORLD_READ WORLD_EXECUTE)


# Add flags for compiling against LLVM.
#
add_definitions(${LLVM_DEFINITIONS})
set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS
  $<$<CONFIG:Release>:NDEBUG>)
# include_directories(${PROJECT_BINARY_DIR}) --- if we generated .h files here
include_directories(${CMAKE_BINARY_DIR})
include_directories(${PROJECT_SOURCE_DIR}) # needed for gen'ed .cpp files
include_directories(${LLVM_INCLUDE_DIRS})
include_directories(${CLANG_INCLUDE_DIRS}) # only works for LLVM post-4.0

link_directories(${LLVM_LIBRARY_DIRS})

llvm_map_components_to_libnames(LLVM_LIBS
  coverage
  irreader
  mcparser
  objcarcopts
  option
  passes
  profiledata
  support
)

set(CLANG_LIBS
  clangStaticAnalyzerFrontend
  clangStaticAnalyzerCheckers
  clangStaticAnalyzerCore
  clangFrontendTool
  clangFrontend
  clangDriver
  clangSerialization
  clangCodeGen
  clangParse
  clangSema
  clangAnalysis
  clangRewriteFrontend
  clangRewrite
  clangAST
  clangBasic
  clangEdit
  clangLex
  clangARCMigrate
)

add_executable(clang_delta
  ${CMAKE_BINARY_DIR}/config.h
  AggregateToScalar.cpp
  AggregateToScalar.h
  BinOpSimplification.cpp
  BinOpSimplification.h
  CallExprToValue.cpp
  CallExprToValue.h
  ClangDelta.cpp
  ClassTemplateToClass.cpp
  ClassTemplateToClass.h
  CombineGlobalVarDecl.cpp
  CombineGlobalVarDecl.h
  CombineLocalVarDecl.cpp
  CombineLocalVarDecl.h
  CommonParameterRewriteVisitor.h
  CommonRenameClassRewriteVisitor.h
  CommonStatementVisitor.h
  CommonTemplateArgumentVisitor.h
  CopyPropagation.cpp
  CopyPropagation.h
  EmptyStructToInt.cpp
  EmptyStructToInt.h
  ExpressionDetector.cpp
  ExpressionDetector.h
  InstantiateTemplateParam.cpp
  InstantiateTemplateParam.h
  InstantiateTemplateTypeParamToInt.cpp
  InstantiateTemplateTypeParamToInt.h
  LiftAssignmentExpr.cpp
  LiftAssignmentExpr.h
  LocalToGlobal.cpp
  LocalToGlobal.h
  MoveFunctionBody.cpp
  MoveFunctionBody.h
  MoveGlobalVar.cpp
  MoveGlobalVar.h
  ParamToGlobal.cpp
  ParamToGlobal.h
  ParamToLocal.cpp
  ParamToLocal.h
  ReduceArrayDim.cpp
  ReduceArrayDim.h
  ReduceArraySize.cpp
  ReduceArraySize.h
  ReduceClassTemplateParameter.cpp
  ReduceClassTemplateParameter.h
  ReducePointerLevel.cpp
  ReducePointerLevel.h
  ReducePointerPairs.cpp
  ReducePointerPairs.h
  RemoveAddrTaken.cpp
  RemoveAddrTaken.h
  RemoveArray.cpp
  RemoveArray.h
  RemoveBaseClass.cpp
  RemoveBaseClass.h
  RemoveCtorInitializer.cpp
  RemoveCtorInitializer.h
  RemoveEnumMemberValue.cpp
  RemoveEnumMemberValue.h
  RemoveNamespace.cpp
  RemoveNamespace.h
  RemoveNestedFunction.cpp
  RemoveNestedFunction.h
  RemovePointer.cpp
  RemovePointer.h
  RemoveTrivialBaseTemplate.cpp
  RemoveTrivialBaseTemplate.h
  RemoveUnresolvedBase.cpp
  RemoveUnresolvedBase.h
  RemoveUnusedEnumMember.cpp
  RemoveUnusedEnumMember.h
  RemoveUnusedFunction.cpp
  RemoveUnusedFunction.h
  RemoveUnusedOuterClass.cpp
  RemoveUnusedOuterClass.h
  RemoveUnusedStructField.cpp
  RemoveUnusedStructField.h
  RemoveUnusedVar.cpp
  RemoveUnusedVar.h
  RenameCXXMethod.cpp
  RenameCXXMethod.h
  RenameClass.cpp
  RenameClass.h
  RenameFun.cpp
  RenameFun.h
  RenameParam.cpp
  RenameParam.h
  RenameVar.cpp
  RenameVar.h
  ReplaceArrayAccessWithIndex.cpp
  ReplaceArrayAccessWithIndex.h
  ReplaceArrayIndexVar.cpp
  ReplaceArrayIndexVar.h
  ReplaceCallExpr.cpp
  ReplaceCallExpr.h
  ReplaceClassWithBaseTemplateSpec.cpp
  ReplaceClassWithBaseTemplateSpec.h
  ReplaceDependentName.cpp
  ReplaceDependentName.h
  ReplaceDependentTypedef.cpp
  ReplaceDependentTypedef.h
  ReplaceDerivedClass.cpp
  ReplaceDerivedClass.h
  ReplaceFunctionDefWithDecl.cpp
  ReplaceFunctionDefWithDecl.h
  ReplaceOneLevelTypedefType.cpp
  ReplaceOneLevelTypedefType.h
  ReplaceSimpleTypedef.cpp
  ReplaceSimpleTypedef.h
  ReplaceUndefinedFunction.cpp
  ReplaceUndefinedFunction.h
  ReturnVoid.cpp
  ReturnVoid.h
  RewriteUtils.cpp
  RewriteUtils.h
  SimpleInliner.cpp
  SimpleInliner.h
  SimplifyCallExpr.cpp
  SimplifyCallExpr.h
  SimplifyCommaExpr.cpp
  SimplifyCommaExpr.h
  SimplifyDependentTypedef.cpp
  SimplifyDependentTypedef.h
  SimplifyIf.cpp
  SimplifyIf.h
  SimplifyNestedClass.cpp
  SimplifyNestedClass.h
  SimplifyRecursiveTemplateInstantiation.cpp
  SimplifyRecursiveTemplateInstantiation.h
  SimplifyStruct.cpp
  SimplifyStruct.h
  SimplifyStructUnionDecl.cpp
  SimplifyStructUnionDecl.h
  TemplateArgToInt.cpp
  TemplateArgToInt.h
  TemplateNonTypeArgToInt.cpp
  TemplateNonTypeArgToInt.h
  Transformation.cpp
  Transformation.h
  TransformationManager.cpp
  TransformationManager.h
  UnifyFunctionDecl.cpp
  UnifyFunctionDecl.h
  UnionToStruct.cpp
  UnionToStruct.h
  VectorToArray.cpp
  VectorToArray.h
  ${PROJECT_BINARY_DIR}/git_version.cpp
  git_version.h
)

target_link_libraries(clang_delta ${CLANG_LIBS} ${LLVM_LIBS})

# Custom target for running clang_delta tests
#
add_custom_target(check-clang-delta
  COMMAND ${LLVM_TOOLS_BINARY_DIR}/llvm-lit
          -sv ${CMAKE_CURRENT_BINARY_DIR}/tests
  DEPENDS clang_delta)

# On Windows, we also need to link with "Version.dll" system library.
# See <https://github.com/csmith-project/creduce/pull/126>.
if("${CMAKE_SYSTEM_NAME}" STREQUAL "Windows")
  target_link_libraries(clang_delta Version)
endif()

install(TARGETS clang_delta
  RUNTIME DESTINATION "libexec"
)
# If binary is read-only, then installing may fail with an error:
# CMake Error at cmake_install.cmake:45 (FILE):
#  file RPATH_REMOVE could not remove RPATH from file:
#    /disk2/randtest/install/libexec/clang_delta
#  Error opening file for update.
#
# Do I want RPATH at all?  We can turn it off, by setting CMAKE_SKIP_RPATH
# https://cmake.org/cmake/help/v2.8.8/cmake.html#variable%3aCMAKE_SKIP_RPATH
# See also the stuff about RPATH for `set_target_properties', which I don't
# really grok:
# https://cmake.org/cmake/help/v2.8.8/cmake.html#command:set_target_properties
#
#  PERMISSIONS
#    OWNER_READ OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE

###############################################################################

## End of file.

=== unifdef/CMakeLists.txt ===
## -*- mode: CMake -*-
##
## Copyright (c) 2016 The University of Utah
## All rights reserved.
##
## This file is distributed under the University of Illinois Open Source
## License.  See the file COPYING for details.

###############################################################################

cmake_minimum_required(VERSION 2.8.12)

###############################################################################

project(unifdef)

include_directories(${PROJECT_BINARY_DIR})
include_directories(${PROJECT_SOURCE_DIR})
include_directories(${CMAKE_BINARY_DIR})

add_executable(unifdef
  unifdef.c
  unifdef.h
  version.h
  )

###############################################################################

install(TARGETS unifdef
  RUNTIME DESTINATION "libexec"
  )

###############################################################################

## End of file.

=== debian/changelog ===
creduce (2.8.0~20180311-1) unstable; urgency=medium

  * New upstream snapshot.
  * Build using llvm-6.0.

 -- Matthias Klose <doko@debian.org>  Mon, 12 Mar 2018 09:17:25 +0100

=== debian/control ===
Source: creduce
Section: devel
Priority: optional
Maintainer: Debian GCC Maintainers <debian-gcc@lists.debian.org>
Uploaders: Matthias Klose <doko@debian.org>
Build-Depends: debhelper (>= 9), dh-autoreconf,
  flex,
  libedit-dev, zlib1g-dev,
  llvm-6.0-dev, libclang-6.0-dev,
  clang-6.0, clang-format-6.0,
  libbenchmark-timer-perl, libsys-cpu-perl,
  libfile-which-perl, libregexp-common-perl, libexporter-lite-perl,
  libgetopt-tabular-perl, libterm-readkey-perl,
# for running the tests:
  frama-c-base
Build-Conflicts: kcc
Standards-Version: 4.1.3
Homepage: http://embed.cs.utah.edu/creduce/

Package: creduce
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
  clang-format-4.0,
  libbenchmark-timer-perl, libsys-cpu-perl,
  libfile-which-perl, libregexp-common-perl, libexporter-lite-perl,
  libgetopt-tabular-perl, libterm-readkey-perl,
Recommends: gcc | clang
Description: Test-Case Reduction for C Compiler Bugs
 C-Reduce is a tool which takes a large C or C++ program that has a
 property of interest (such as triggering a compiler bug) and
 automatically produces a much smaller C/C++ program that has the same
 property.  It is intended for use by people who discover and report
 bugs in compilers and other tools that process C/C++ code.

## creduce 2.8.0~20180315

=== debian/changelog ===
creduce (2.8.0~20180315-1) unstable; urgency=medium

  * New upstream snapshot.
  * Update clang-format dependency to 6.0.

 -- Matthias Klose <doko@debian.org>  Thu, 22 Mar 2018 11:20:21 +0800

## creduce 2.8.0~20180422

=== clang_delta/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 ## -*- mode: CMake -*-
 ##
-## Copyright (c) 2012, 2013, 2014, 2015, 2016, 2017 The University of Utah
+## Copyright (c) 2012, 2013, 2014, 2015, 2016, 2017, 2018 The University of Utah
 ## All rights reserved.
 ##
 ## This file is distributed under the University of Illinois Open Source

=== creduce/CMakeLists.txt ===
## -*- mode: CMake -*-
##
## Copyright (c) 2012, 2013, 2014, 2015, 2016 The University of Utah
## All rights reserved.
##
## This file is distributed under the University of Illinois Open Source
## License.  See the file COPYING for details.

###############################################################################

cmake_minimum_required(VERSION 2.8.12)

project(creduce_perl)

set(BIN_DIR "${CMAKE_INSTALL_PREFIX}/bin")
set(LIB_EXEC_DIR "${CMAKE_INSTALL_PREFIX}/libexec")
set(PKG_DATA_DIR "${CMAKE_INSTALL_PREFIX}/share/${creduce_PACKAGE}")
set(PERL_LIB_DIR "${PKG_DATA_DIR}/perl")

###############################################################################

# find_package(LLVM) is done by the topmost "CMakeLists.txt" file.

# include(FindPerl) is done by the topmost "CMakeLists.txt" file.

###############################################################################

# Check for the run-time prerequisites of C-Reduce.  We only warn the user when
# these are not found at configure time.  Let the user install the dependencies
# later.
#
set(missing_required_runtime_prereq "no")
set(missing_optional_runtime_prereq "no")
set(required_perl_modules "yes")
set(optional_perl_modules "yes")

find_program(CLANG_FORMAT
  "clang-format${CMAKE_EXECUTABLE_SUFFIX}"
  PATHS "${LLVM_TOOLS_BINARY_DIR}"
  )
if(NOT CLANG_FORMAT)
  message(STATUS "`clang-format${CMAKE_EXECUTABLE_SUFFIX}' was not found")
  set(missing_required_runtime_prereq "yes")
endif()

###

execute_process(COMMAND ${PERL_EXECUTABLE} -MExporter::Lite -e ""
  ERROR_QUIET
  RESULT_VARIABLE status
  )
if(status)
  message(STATUS "Required Perl module `Exporter::Lite' was not found")
  set(missing_required_runtime_prereq "yes")
  set(required_perl_modules "no")
endif()
#
execute_process(COMMAND ${PERL_EXECUTABLE} -MFile::Which -e ""
  ERROR_QUIET
  RESULT_VARIABLE status
  )
if(status)
  message(STATUS "Required Perl module `File::Which' was not found")
  set(required_perl_modules "no")
  set(missing_required_runtime_prereq "yes")
endif()
#
execute_process(COMMAND ${PERL_EXECUTABLE} -MGetopt::Tabular -e ""
  ERROR_QUIET
  RESULT_VARIABLE status
  )
if(status)
  message(STATUS "Required Perl module `Getopt::Tabular' was not found")
  set(required_perl_modules "no")
  set(missing_required_runtime_prereq "yes")
endif()
#
execute_process(COMMAND ${PERL_EXECUTABLE} -MRegexp::Common -e ""
  ERROR_QUIET
  RESULT_VARIABLE status
  )
if(status)
  message(STATUS "Required Perl module `Regexp::Common' was not found")
  set(required_perl_modules "no")
  set(missing_required_runtime_prereq "yes")
endif()
#
execute_process(COMMAND ${PERL_EXECUTABLE} -MSys::CPU -e ""
  ERROR_QUIET
  RESULT_VARIABLE status
  )
if(status)
  message(STATUS "Optional Perl module `Sys::CPU' was not found")
  set(optional_perl_modules "no")
  set(missing_optional_runtime_prereq "yes")
endif()
#
execute_process(COMMAND ${PERL_EXECUTABLE} -MTerm::ReadKey -e ""
  ERROR_QUIET
  RESULT_VARIABLE status
  )
if(status)
  message(STATUS "Optional Perl module `Term::ReadKey' was not found")
  set(optional_perl_modules "no")
  set(missing_optional_runtime_prereq "yes")
endif()

###

# Warn about things that will be needed at run time, but which we did not find
# at configure time.
#
# First warn about required run-time dependencies...
#
if(missing_required_runtime_prereq STREQUAL "yes")
  message(WARNING
    "You cannot run C-Reduce until you install missing dependencies!")
endif()

if(required_perl_modules STREQUAL "no")
  message("You must install Perl modules required by C-Reduce.")
endif()
if(NOT CLANG_FORMAT)
  message("You must install `clang-format' before running C-Reduce.")
  set(CLANG_FORMAT "clang-format")
endif()

if(missing_required_runtime_prereq STREQUAL "yes")
  message("Read the INSTALL file for info about C-Reduce dependencies.")
endif()

# ...and then warn about optional run-time dependencies.
#
if(missing_optional_runtime_prereq STREQUAL "yes")
  message("The following optional C-Reduce dependencies were not found.")
endif()

if(optional_perl_modules STREQUAL "no")
  message("One or more useful Perl modules were not found.")
endif()

if(missing_optional_runtime_prereq STREQUAL "yes")
  message("C-Reduce will use these tools if you install them in the future.")
  message("Read the INSTALL file for info about C-Reduce dependencies.")
endif()

###############################################################################

# Generate file "creduce".
#
file(READ "creduce.in" CREDUCE_CONTENT)
string(REPLACE "@perl@" "${PERL_EXECUTABLE}"
  CREDUCE_CONTENT "${CREDUCE_CONTENT}")
# The following is not needed, but triggers a warning in CMake 3.1+.
# See `cmake --help-policy CMP0053'.  Avoid the warning by not doing it.
# string(REPLACE "@PERL@" "${PERL_EXECUTABLE}"
#   CREDUCE_CONTENT "${CREDUCE_CONTENT}")
string(REPLACE "@perllibdir@" "${PERL_LIB_DIR}"
  CREDUCE_CONTENT "${CREDUCE_CONTENT}")
string(REPLACE "@prefix@" "${CMAKE_INSTALL_PREFIX}"
  CREDUCE_CONTENT "${CREDUCE_CONTENT}")
file(WRITE
  "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/creduce"
  "${CREDUCE_CONTENT}")
file(COPY
  "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/creduce"
  DESTINATION "${PROJECT_BINARY_DIR}"
  FILE_PERMISSIONS
    OWNER_READ OWNER_WRITE OWNER_EXECUTE
    GROUP_READ GROUP_EXECUTE
    WORLD_READ WORLD_EXECUTE
  )

# Generate file "creduce_config.pm".
#
file(READ "creduce_config.pm.in" CREDUCE_CONTENT)
string(REPLACE "@bindir@" "${BIN_DIR}"
  CREDUCE_CONTENT "${CREDUCE_CONTENT}")
string(REPLACE "@libexecdir@" "${LIB_EXEC_DIR}"
  CREDUCE_CONTENT "${CREDUCE_CONTENT}")
string(REPLACE "@PACKAGE_BUGREPORT@" "${creduce_PACKAGE_BUGREPORT}"
  CREDUCE_CONTENT "${CREDUCE_CONTENT}")
string(REPLACE "@PACKAGE_NAME@" "${creduce_PACKAGE_NAME}"
  CREDUCE_CONTENT "${CREDUCE_CONTENT}")
string(REPLACE "@PACKAGE_STRING@" "${creduce_PACKAGE_STRING}"
  CREDUCE_CONTENT "${CREDUCE_CONTENT}")
string(REPLACE "@PACKAGE_URL@" "${creduce_PACKAGE_URL}"
  CREDUCE_CONTENT "${CREDUCE_CONTENT}")
string(REPLACE "@PACKAGE_VERSION@" "${creduce_PACKAGE_VERSION}"
  CREDUCE_CONTENT "${CREDUCE_CONTENT}")
string(REPLACE "@VERSION@" "${creduce_VERSION}"
  CREDUCE_CONTENT "${CREDUCE_CONTENT}")
# ENE: I do not understand why the \'s seem to be required in the following
# match strings.
string(REPLACE "\@GIT_HASH@" "${GIT_HASH}"
  CREDUCE_CONTENT "${CREDUCE_CONTENT}")
string(REPLACE "\@CLANG_FORMAT@" "${CLANG_FORMAT}"
  CREDUCE_CONTENT "${CREDUCE_CONTENT}")
file(WRITE
  "${PROJECT_BINARY_DIR}/creduce_config.pm"
  "${CREDUCE_CONTENT}"
  )

###############################################################################

# Copy the Perl modules into the build tree so that we can run C-Reduce there.
#
# Blech!  But listing all the source files is what we do in the Autoconf-based
# build system, too.
#
add_custom_target(Modules ALL
  COMMAND ${CMAKE_COMMAND} -E copy_if_different
    ${PROJECT_SOURCE_DIR}/creduce_regexes.pm
    ${PROJECT_BINARY_DIR}
  COMMAND ${CMAKE_COMMAND} -E copy_if_different
    ${PROJECT_SOURCE_DIR}/creduce_utils.pm
    ${PROJECT_BINARY_DIR}
  COMMAND ${CMAKE_COMMAND} -E copy_if_different
    ${PROJECT_SOURCE_DIR}/pass_balanced.pm
    ${PROJECT_BINARY_DIR}
  COMMAND ${CMAKE_COMMAND} -E copy_if_different
    ${PROJECT_SOURCE_DIR}/pass_blank.pm
    ${PROJECT_BINARY_DIR}
  COMMAND ${CMAKE_COMMAND} -E copy_if_different
    ${PROJECT_SOURCE_DIR}/pass_clang.pm
    ${PROJECT_BINARY_DIR}
  COMMAND ${CMAKE_COMMAND} -E copy_if_different
    ${PROJECT_SOURCE_DIR}/pass_clang_binsrch.pm
    ${PROJECT_BINARY_DIR}
  COMMAND ${CMAKE_COMMAND} -E copy_if_different
    ${PROJECT_SOURCE_DIR}/pass_clex.pm
    ${PROJECT_BINARY_DIR}
  COMMAND ${CMAKE_COMMAND} -E copy_if_different
    ${PROJECT_SOURCE_DIR}/pass_comments.pm
    ${PROJECT_BINARY_DIR}
  COMMAND ${CMAKE_COMMAND} -E copy_if_different
    ${PROJECT_SOURCE_DIR}/pass_include_includes.pm
    ${PROJECT_BINARY_DIR}
  COMMAND ${CMAKE_COMMAND} -E copy_if_different
    ${PROJECT_SOURCE_DIR}/pass_includes.pm
    ${PROJECT_BINARY_DIR}
  COMMAND ${CMAKE_COMMAND} -E copy_if_different
    ${PROJECT_SOURCE_DIR}/pass_indent.pm
    ${PROJECT_BINARY_DIR}
  COMMAND ${CMAKE_COMMAND} -E copy_if_different
    ${PROJECT_SOURCE_DIR}/pass_ints.pm
    ${PROJECT_BINARY_DIR}
  COMMAND ${CMAKE_COMMAND} -E copy_if_different
    ${PROJECT_SOURCE_DIR}/pass_lines.pm
    ${PROJECT_BINARY_DIR}
  COMMAND ${CMAKE_COMMAND} -E copy_if_different
    ${PROJECT_SOURCE_DIR}/pass_peep.pm
    ${PROJECT_BINARY_DIR}
  COMMAND ${CMAKE_COMMAND} -E copy_if_different
    ${PROJECT_SOURCE_DIR}/pass_special.pm
    ${PROJECT_BINARY_DIR}
  COMMAND ${CMAKE_COMMAND} -E copy_if_different
    ${PROJECT_SOURCE_DIR}/pass_ternary.pm
    ${PROJECT_BINARY_DIR}
  COMMAND ${CMAKE_COMMAND} -E copy_if_different
    ${PROJECT_SOURCE_DIR}/pass_unifdef.pm
    ${PROJECT_BINARY_DIR}
  COMMENT "Copying C-Reduce Perl modules to build tree"
  )

###############################################################################

install(PROGRAMS
  "${PROJECT_BINARY_DIR}/creduce"
  DESTINATION "${BIN_DIR}"
  )

install(FILES
  "${PROJECT_BINARY_DIR}/creduce_config.pm"
  DESTINATION "${PERL_LIB_DIR}"
  )
install(DIRECTORY
  "${PROJECT_SOURCE_DIR}/"
  DESTINATION "${PERL_LIB_DIR}"
  FILES_MATCHING
    PATTERN "CMakeFiles" EXCLUDE
    PATTERN "*.pm"
  )

###############################################################################

## End of file.

=== debian/changelog ===
creduce (2.8.0~20180422-1) unstable; urgency=medium

  * New upstream snapshot.

 -- Matthias Klose <doko@debian.org>  Sun, 22 Apr 2018 09:45:30 +0200

=== debian/control ===
--- 
+++ 
@@ -20,7 +20,7 @@
 Package: creduce
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends},
-  clang-format-4.0,
+  clang-format-6.0,
   libbenchmark-timer-perl, libsys-cpu-perl,
   libfile-which-perl, libregexp-common-perl, libexporter-lite-perl,
   libgetopt-tabular-perl, libterm-readkey-perl,

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

CLANG_V	= 6.0
CLANG	= clang-$(CLANG_V)
GCC	= gcc

%:
	dh $@  --with autoreconf --parallel

override_dh_auto_configure:
	dh_auto_configure -- --with-llvm=/usr/lib/llvm-$(CLANG_V) CLANG_FORMAT=clang-format-$(CLANG_V)
	
override_dh_auto_build:
	dh_auto_build

ifeq ($(DEB_HOST_ARCH),$(DEB_BUILD_ARCH))
	if which help2man >/dev/null 2>&1; then \
	  v=$$(creduce/creduce --help| awk '/^creduce/ { print $$2 }'); \
	  help2man --name='C and C++ program reducer' --version-string=$$v creduce/creduce > debian/creduce.1; \
	fi
endif

override_dh_auto_test:
# these are time consuming ...
ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
  ifeq (,$(filter $(DEB_HOST_ARCH),m68k sh4 s390 sparc))
	cd tests && CLANG="$(CLANG)" GCC="$(GCC)" ./run_tests
  endif
endif

override_dh_auto_install:
	dh_auto_install
	install -D -m 644 debian/creduce.1 debian/creduce/usr/share/man/man1/creduce.1

override_dh_auto_clean:
	rm -rf tests/tmp_*
	dh_auto_clean

## creduce 2.8.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 ## -*- mode: CMake -*-
 ##
-## Copyright (c) 2012, 2013, 2014, 2015, 2016, 2017 The University of Utah
+## Copyright (c) 2012, 2013, 2014, 2015, 2016, 2017, 2018 The University of Utah
 ## All rights reserved.
 ##
 ## This file is distributed under the University of Illinois Open Source
@@ -26,8 +26,8 @@
 find_package(LLVM REQUIRED CONFIG NO_CMAKE_BUILDS_PATH)
 message(STATUS "Found LLVM ${LLVM_PACKAGE_VERSION}")
 message(STATUS "Using LLVMConfig.cmake in ${LLVM_DIR}")
-if (${LLVM_PACKAGE_VERSION} VERSION_LESS "4.0")
-  message(FATAL_ERROR "C-Reduce requires LLVM 4.0 or later")
+if (${LLVM_PACKAGE_VERSION} VERSION_LESS "6.0")
+  message(FATAL_ERROR "C-Reduce requires LLVM 6.0 or later")
 endif()
 #
 # Do this here, too, just to keep it with the LLVM check above.
@@ -56,7 +56,7 @@
 # `git archive' inserts the abbreviated hash of the archive's commit into this
 # file.  (See the `.gitattributes' file.)
 #
-set(GIT_HASH "$Format:%h$")
+set(GIT_HASH "91bdbda")
 if(GIT_HASH MATCHES "^\\$")
   ## METHOD 2: The source tree is a git repository.
   get_git_head_revision(GIT_REFSPEC GIT_HASH)

=== clang_delta/CMakeLists.txt ===
--- 
+++ 
@@ -242,7 +242,11 @@
   git_version.h
 )
 
-target_link_libraries(clang_delta ${CLANG_LIBS} ${LLVM_LIBS})
+# ENE, LLVM 6.0: LLVM_LIBS end up in the link command line anyway.  I'm not
+# quite sure why!  But if you list LLVM_LIBS here, the `clang_delta' binary
+# can end up with dynamic link errors when it runs (multiply defined symbols).
+#
+target_link_libraries(clang_delta ${CLANG_LIBS})
 
 # Custom target for running clang_delta tests
 #

=== debian/changelog ===
creduce (2.8.0-1) unstable; urgency=medium

  * C-Reduce 2.8.0 release.
  * Remove (build-) dependency on libsys-cpu-perl.

 -- Matthias Klose <doko@debian.org>  Wed, 11 Jul 2018 14:41:21 +0200

=== debian/control ===
--- 
+++ 
@@ -8,20 +8,20 @@
   libedit-dev, zlib1g-dev,
   llvm-6.0-dev, libclang-6.0-dev,
   clang-6.0, clang-format-6.0,
-  libbenchmark-timer-perl, libsys-cpu-perl,
+  libbenchmark-timer-perl,
   libfile-which-perl, libregexp-common-perl, libexporter-lite-perl,
   libgetopt-tabular-perl, libterm-readkey-perl,
 # for running the tests:
   frama-c-base
 Build-Conflicts: kcc
-Standards-Version: 4.1.3
+Standards-Version: 4.1.4
 Homepage: http://embed.cs.utah.edu/creduce/
 
 Package: creduce
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends},
   clang-format-6.0,
-  libbenchmark-timer-perl, libsys-cpu-perl,
+  libbenchmark-timer-perl,
   libfile-which-perl, libregexp-common-perl, libexporter-lite-perl,
   libgetopt-tabular-perl, libterm-readkey-perl,
 Recommends: gcc | clang

## creduce 2.9~20181016

=== CMakeLists.txt ===
--- 
+++ 
@@ -56,7 +56,7 @@
 # `git archive' inserts the abbreviated hash of the archive's commit into this
 # file.  (See the `.gitattributes' file.)
 #
-set(GIT_HASH "91bdbda")
+set(GIT_HASH "$Format:%h$")
 if(GIT_HASH MATCHES "^\\$")
   ## METHOD 2: The source tree is a git repository.
   get_git_head_revision(GIT_REFSPEC GIT_HASH)
@@ -90,11 +90,11 @@
 set(creduce_PACKAGE			"creduce")
 set(creduce_PACKAGE_BUGREPORT		"creduce-bugs@flux.utah.edu")
 set(creduce_PACKAGE_NAME		"creduce")
-set(creduce_PACKAGE_STRING		"creduce 2.8.0")
+set(creduce_PACKAGE_STRING		"creduce 2.9.0")
 set(creduce_PACKAGE_TARNAME		"creduce")
 set(creduce_PACKAGE_URL			"http://embed.cs.utah.edu/creduce/")
-set(creduce_PACKAGE_VERSION		"2.8.0")
-set(creduce_VERSION			"2.8.0")
+set(creduce_PACKAGE_VERSION		"2.9.0")
+set(creduce_VERSION			"2.9.0")
 
 # FIXME: Should be determined automatically.
 set(YYTEXT_POINTER 1)

=== creduce/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 ## -*- mode: CMake -*-
 ##
-## Copyright (c) 2012, 2013, 2014, 2015, 2016 The University of Utah
+## Copyright (c) 2012, 2013, 2014, 2015, 2016, 2018 The University of Utah
 ## All rights reserved.
 ##
 ## This file is distributed under the University of Illinois Open Source
@@ -83,16 +83,6 @@
   message(STATUS "Required Perl module `Regexp::Common' was not found")
   set(required_perl_modules "no")
   set(missing_required_runtime_prereq "yes")
-endif()
-#
-execute_process(COMMAND ${PERL_EXECUTABLE} -MSys::CPU -e ""
-  ERROR_QUIET
-  RESULT_VARIABLE status
-  )
-if(status)
-  message(STATUS "Optional Perl module `Sys::CPU' was not found")
-  set(optional_perl_modules "no")
-  set(missing_optional_runtime_prereq "yes")
 endif()
 #
 execute_process(COMMAND ${PERL_EXECUTABLE} -MTerm::ReadKey -e ""

=== debian/changelog ===
creduce (2.9~20181016-1) unstable; urgency=medium

  * Snapshot, taken from the llvm7 branch.

 -- Matthias Klose <doko@debian.org>  Tue, 16 Oct 2018 10:08:37 +0200

=== debian/control ===
--- 
+++ 
@@ -6,21 +6,21 @@
 Build-Depends: debhelper (>= 9), dh-autoreconf,
   flex,
   libedit-dev, zlib1g-dev,
-  llvm-6.0-dev, libclang-6.0-dev,
-  clang-6.0, clang-format-6.0,
+  llvm-7-dev, libclang-7-dev,
+  clang-7, clang-format-7,
   libbenchmark-timer-perl,
   libfile-which-perl, libregexp-common-perl, libexporter-lite-perl,
   libgetopt-tabular-perl, libterm-readkey-perl,
 # for running the tests:
   frama-c-base
 Build-Conflicts: kcc
-Standards-Version: 4.1.4
+Standards-Version: 4.2.1
 Homepage: http://embed.cs.utah.edu/creduce/
 
 Package: creduce
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends},
-  clang-format-6.0,
+  clang-format-7,
   libbenchmark-timer-perl,
   libfile-which-perl, libregexp-common-perl, libexporter-lite-perl,
   libgetopt-tabular-perl, libterm-readkey-perl,

=== debian/rules ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
 
-CLANG_V	= 6.0
+CLANG_V	= 7
 CLANG	= clang-$(CLANG_V)
 GCC	= gcc

## creduce 2.9~20181211

=== debian/changelog ===
creduce (2.9~20181211-1) unstable; urgency=medium

  * Snapshot, taken from the llvm7 branch.

 -- Matthias Klose <doko@debian.org>  Tue, 11 Dec 2018 12:24:25 +0100

## creduce 2.9~20190320

=== debian/changelog ===
creduce (2.9~20190320-0ubuntu1) disco; urgency=medium

  * Snapshot, taken from the trunk.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 20 Mar 2019 15:01:21 +0100

=== debian/control ===
--- 
+++ 
@@ -14,13 +14,13 @@
 # for running the tests:
   frama-c-base
 Build-Conflicts: kcc
-Standards-Version: 4.2.1
+Standards-Version: 4.3.0
 Homepage: http://embed.cs.utah.edu/creduce/
 
 Package: creduce
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends},
-  clang-format-7,
+  clang-format-8,
   libbenchmark-timer-perl,
   libfile-which-perl, libregexp-common-perl, libexporter-lite-perl,
   libgetopt-tabular-perl, libterm-readkey-perl,

## creduce 2.9~20190428

=== creduce/CMakeLists.txt ===
--- 
+++ 
@@ -224,6 +224,9 @@
     ${PROJECT_SOURCE_DIR}/pass_comments.pm
     ${PROJECT_BINARY_DIR}
   COMMAND ${CMAKE_COMMAND} -E copy_if_different
+    ${PROJECT_SOURCE_DIR}/pass_ifs.pm
+    ${PROJECT_BINARY_DIR}
+  COMMAND ${CMAKE_COMMAND} -E copy_if_different
     ${PROJECT_SOURCE_DIR}/pass_include_includes.pm
     ${PROJECT_BINARY_DIR}
   COMMAND ${CMAKE_COMMAND} -E copy_if_different
@@ -234,6 +237,9 @@
     ${PROJECT_BINARY_DIR}
   COMMAND ${CMAKE_COMMAND} -E copy_if_different
     ${PROJECT_SOURCE_DIR}/pass_ints.pm
+    ${PROJECT_BINARY_DIR}
+  COMMAND ${CMAKE_COMMAND} -E copy_if_different
+    ${PROJECT_SOURCE_DIR}/pass_line_markers.pm
     ${PROJECT_BINARY_DIR}
   COMMAND ${CMAKE_COMMAND} -E copy_if_different
     ${PROJECT_SOURCE_DIR}/pass_lines.pm

=== debian/changelog ===
creduce (2.9~20190428-1) experimental; urgency=medium

  * Snapshot, taken from the llvm8 branch.

 -- Matthias Klose <doko@debian.org>  Sun, 28 Apr 2019 10:19:53 +0200

=== debian/rules ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
 
-CLANG_V	= 7
+CLANG_V	= 8
 CLANG	= clang-$(CLANG_V)
 GCC	= gcc

## creduce 2.9.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 ## -*- mode: CMake -*-
 ##
-## Copyright (c) 2012, 2013, 2014, 2015, 2016, 2017, 2018 The University of Utah
+## Copyright (c) 2012, 2013, 2014, 2015, 2016, 2017, 2018, 2019 The University of Utah
 ## All rights reserved.
 ##
 ## This file is distributed under the University of Illinois Open Source
@@ -26,8 +26,8 @@
 find_package(LLVM REQUIRED CONFIG NO_CMAKE_BUILDS_PATH)
 message(STATUS "Found LLVM ${LLVM_PACKAGE_VERSION}")
 message(STATUS "Using LLVMConfig.cmake in ${LLVM_DIR}")
-if (${LLVM_PACKAGE_VERSION} VERSION_LESS "6.0")
-  message(FATAL_ERROR "C-Reduce requires LLVM 6.0 or later")
+if (${LLVM_PACKAGE_VERSION} VERSION_LESS "7.0")
+  message(FATAL_ERROR "C-Reduce requires LLVM 7.0 or later")
 endif()
 #
 # Do this here, too, just to keep it with the LLVM check above.
@@ -56,7 +56,7 @@
 # `git archive' inserts the abbreviated hash of the archive's commit into this
 # file.  (See the `.gitattributes' file.)
 #
-set(GIT_HASH "$Format:%h$")
+set(GIT_HASH "0fc288e")
 if(GIT_HASH MATCHES "^\\$")
   ## METHOD 2: The source tree is a git repository.
   get_git_head_revision(GIT_REFSPEC GIT_HASH)

=== debian/changelog ===
creduce (2.9.0-1) unstable; urgency=medium

  * C-Reduce 2.9.0 release.
  * Link with libatomic when needed.

 -- Matthias Klose <doko@debian.org>  Wed, 08 May 2019 18:11:11 +0200

=== debian/control ===
--- 
+++ 
@@ -20,7 +20,7 @@
 Package: creduce
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends},
-  clang-format-8,
+  clang-format-7,
   libbenchmark-timer-perl,
   libfile-which-perl, libregexp-common-perl, libexporter-lite-perl,
   libgetopt-tabular-perl, libterm-readkey-perl,

=== debian/rules ===
--- 
+++ 
@@ -6,9 +6,13 @@
 
 DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
 
-CLANG_V	= 8
+CLANG_V	= 7
 CLANG	= clang-$(CLANG_V)
 GCC	= gcc
+
+ifneq (,$(filter $(DEB_HOST_ARCH),armel))
+  export LIBATOMIC = -latomic
+endif
 
 %:
 	dh $@  --with autoreconf --parallel

## creduce 2.10.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -26,8 +26,8 @@
 find_package(LLVM REQUIRED CONFIG NO_CMAKE_BUILDS_PATH)
 message(STATUS "Found LLVM ${LLVM_PACKAGE_VERSION}")
 message(STATUS "Using LLVMConfig.cmake in ${LLVM_DIR}")
-if (${LLVM_PACKAGE_VERSION} VERSION_LESS "7.0")
-  message(FATAL_ERROR "C-Reduce requires LLVM 7.0 or later")
+if (${LLVM_PACKAGE_VERSION} VERSION_LESS "8.0")
+  message(FATAL_ERROR "C-Reduce requires LLVM 8.0 or later")
 endif()
 #
 # Do this here, too, just to keep it with the LLVM check above.
@@ -56,7 +56,7 @@
 # `git archive' inserts the abbreviated hash of the archive's commit into this
 # file.  (See the `.gitattributes' file.)
 #
-set(GIT_HASH "0fc288e")
+set(GIT_HASH "fb91843")
 if(GIT_HASH MATCHES "^\\$")
   ## METHOD 2: The source tree is a git repository.
   get_git_head_revision(GIT_REFSPEC GIT_HASH)
@@ -90,11 +90,11 @@
 set(creduce_PACKAGE			"creduce")
 set(creduce_PACKAGE_BUGREPORT		"creduce-bugs@flux.utah.edu")
 set(creduce_PACKAGE_NAME		"creduce")
-set(creduce_PACKAGE_STRING		"creduce 2.9.0")
+set(creduce_PACKAGE_STRING		"creduce 2.10.0")
 set(creduce_PACKAGE_TARNAME		"creduce")
 set(creduce_PACKAGE_URL			"http://embed.cs.utah.edu/creduce/")
-set(creduce_PACKAGE_VERSION		"2.9.0")
-set(creduce_VERSION			"2.9.0")
+set(creduce_PACKAGE_VERSION		"2.10.0")
+set(creduce_VERSION			"2.10.0")
 
 # FIXME: Should be determined automatically.
 set(YYTEXT_POINTER 1)

=== debian/changelog ===
creduce (2.10.0-1~18.04) bionic-proposed; urgency=medium

  * SRU: LP: #1834654. Backport 2.10.0 to the 18.04 LTS release.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 28 Jun 2019 16:46:26 +0200

creduce (2.10.0-1) experimental; urgency=medium

  * C-Reduce 2.10.0 release.
  * Build using llvm-8.

 -- Matthias Klose <doko@debian.org>  Mon, 27 May 2019 20:53:41 +0200

=== debian/control ===
--- 
+++ 
@@ -6,8 +6,8 @@
 Build-Depends: debhelper (>= 9), dh-autoreconf,
   flex,
   libedit-dev, zlib1g-dev,
-  llvm-7-dev, libclang-7-dev,
-  clang-7, clang-format-7,
+  llvm-8-dev, libclang-8-dev,
+  clang-8, clang-format-8,
   libbenchmark-timer-perl,
   libfile-which-perl, libregexp-common-perl, libexporter-lite-perl,
   libgetopt-tabular-perl, libterm-readkey-perl,
@@ -20,7 +20,7 @@
 Package: creduce
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends},
-  clang-format-7,
+  clang-format-8,
   libbenchmark-timer-perl,
   libfile-which-perl, libregexp-common-perl, libexporter-lite-perl,
   libgetopt-tabular-perl, libterm-readkey-perl,

=== debian/rules ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
 
-CLANG_V	= 7
+CLANG_V	= 8
 CLANG	= clang-$(CLANG_V)
 GCC	= gcc

## creduce 2.10.0%2B20220116

=== debian/changelog ===
creduce (2.10.0+20220116-1) unstable; urgency=medium

  * New upstream snapshot, taken from the llvm-13 branch.

 -- Matthias Klose <doko@debian.org>  Mon, 05 Sep 2022 22:13:52 +0200

creduce (2.10.0+20201029-3) unstable; urgency=medium

  * Fix LLVM 9 build dependencies on armel, armhf.
  * Run the tests again, finally frama-c-base is available again.

 -- Matthias Klose <doko@debian.org>  Sat, 09 Jan 2021 15:59:48 +0100

creduce (2.10.0+20201029-2) unstable; urgency=medium

  * Build using LLVM 9 on armel, armhf. See #979495.
  * Bump debhelper and standards versions.
  * Fix man page (Michael R. Crusoe). Closes: #961004.

 -- Matthias Klose <doko@debian.org>  Fri, 08 Jan 2021 14:22:00 +0100

creduce (2.10.0+20201029-1) unstable; urgency=medium

  * New upstream snapshot, taken from the llvm-11 branch.
  * Bump debhelper version.

 -- Matthias Klose <doko@debian.org>  Thu, 29 Oct 2020 19:36:55 +0100

creduce (2.10.0+20200325-1) unstable; urgency=medium

  * 

 -- Matthias Klose <doko@debian.org>  Wed, 25 Mar 2020 18:24:54 +0100

creduce (2.10.0+20200116-2) unstable; urgency=medium

  * Build using llvm-10.
  * Bump standards version .

 -- Matthias Klose <doko@debian.org>  Mon, 09 Mar 2020 12:09:18 +0100

creduce (2.10.0+20200116-1) unstable; urgency=medium

  * New upstream snapshot.
  * Build using llvm-9.
  * Don't run the tests, frama-c-base removed in unstable. Closes: #945886.

 -- Matthias Klose <doko@debian.org>  Thu, 16 Jan 2020 12:24:59 +0100

creduce (2.10.0-2) unstable; urgency=medium

  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Sat, 17 Aug 2019 14:15:57 +0200

## creduce 2.10.0+20200116

=== CMakeLists.txt ===
--- 
+++ 
@@ -56,7 +56,7 @@
 # `git archive' inserts the abbreviated hash of the archive's commit into this
 # file.  (See the `.gitattributes' file.)
 #
-set(GIT_HASH "fb91843")
+set(GIT_HASH "$Format:%h$")
 if(GIT_HASH MATCHES "^\\$")
   ## METHOD 2: The source tree is a git repository.
   get_git_head_revision(GIT_REFSPEC GIT_HASH)
@@ -90,11 +90,11 @@
 set(creduce_PACKAGE			"creduce")
 set(creduce_PACKAGE_BUGREPORT		"creduce-bugs@flux.utah.edu")
 set(creduce_PACKAGE_NAME		"creduce")
-set(creduce_PACKAGE_STRING		"creduce 2.10.0")
+set(creduce_PACKAGE_STRING		"creduce 2.11.0")
 set(creduce_PACKAGE_TARNAME		"creduce")
 set(creduce_PACKAGE_URL			"http://embed.cs.utah.edu/creduce/")
-set(creduce_PACKAGE_VERSION		"2.10.0")
-set(creduce_VERSION			"2.10.0")
+set(creduce_PACKAGE_VERSION		"2.11.0")
+set(creduce_VERSION			"2.11.0")
 
 # FIXME: Should be determined automatically.
 set(YYTEXT_POINTER 1)

=== clang_delta/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 ## -*- mode: CMake -*-
 ##
-## Copyright (c) 2012, 2013, 2014, 2015, 2016, 2017, 2018 The University of Utah
+## Copyright (c) 2012, 2013, 2014, 2015, 2016, 2017, 2018, 2019 The University of Utah
 ## All rights reserved.
 ##
 ## This file is distributed under the University of Illinois Open Source
@@ -57,6 +57,23 @@
 
 link_directories(${LLVM_LIBRARY_DIRS})
 
+# ENE: Note that LLVM_LIBS is unused.
+#
+# The CLANG_LIBS defined below depend on various LLVM libraries.  When we do
+# `target_link_libraries(clang_delta ${CLANG_LIBS})`, CMake's automatic library
+# dependency tracking adds ("is expected to add") the necessary LLVM libraries
+# and other libraries to the link set without us doing anything special.
+#
+# There are reports that this automatic tracking does not always work.  If this
+# is the case for you, you can try adding LLVM_LIBS to the invocation of
+# `target_link_libraries()` later in this file.  There are reports that
+# sometimes this doesn't solve the problem, so caveat emptor.
+#
+# There are reports that including LLVM_LIBS in `target_link_libraries()`, when
+# it is not needed, can cause dynamic link errors when `clang_delta` is run
+# (multiply defined symbols).  This is another reason why we don't include
+# LLVM_LIBS in the `target_link_libraries()` call by default.
+#
 llvm_map_components_to_libnames(LLVM_LIBS
   coverage
   irreader
@@ -242,18 +259,16 @@
   git_version.h
 )
 
-# ENE, LLVM 6.0: LLVM_LIBS end up in the link command line anyway.  I'm not
-# quite sure why!  But if you list LLVM_LIBS here, the `clang_delta' binary
-# can end up with dynamic link errors when it runs (multiply defined symbols).
-#
+# ENE: See comment above about why LLVM_LIBS is not included in this call.
 target_link_libraries(clang_delta ${CLANG_LIBS})
 
-# Custom target for running clang_delta tests
-#
-add_custom_target(check-clang-delta
-  COMMAND ${LLVM_TOOLS_BINARY_DIR}/llvm-lit
-          -sv ${CMAKE_CURRENT_BINARY_DIR}/tests
-  DEPENDS clang_delta)
+# For cases in which the LLVM libraries are shared libraries, remember where
+# the shared libraries are.
+set_target_properties(clang_delta
+  PROPERTIES
+  BUILD_WITH_INSTALL_RPATH "yes"
+  INSTALL_RPATH "${LLVM_LIBRARY_DIRS}"
+)
 
 # On Windows, we also need to link with "Version.dll" system library.
 # See <https://github.com/csmith-project/creduce/pull/126>.
@@ -279,6 +294,15 @@
 #  PERMISSIONS
 #    OWNER_READ OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
 
+#####
+
+# Custom target for running clang_delta tests
+#
+add_custom_target(check-clang-delta
+  COMMAND ${LLVM_TOOLS_BINARY_DIR}/llvm-lit
+          -sv ${CMAKE_CURRENT_BINARY_DIR}/tests
+  DEPENDS clang_delta)
+
 ###############################################################################
 
 ## End of file.

=== delta/test2_multidelta/Makefile ===
# see delta/License.txt for copyright and terms of use

# test and clean multidelta

check:
	./testit

clean:
	rm -f *.ok *.bak file[12].txt log *.log DELTA-STOP

=== debian/changelog ===
creduce (2.10.0+20200116-1ubuntu1) focal; urgency=medium

  * Build-depend on frama-c-base.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 16 Jan 2020 12:53:04 +0100

=== debian/control ===
--- 
+++ 
@@ -6,21 +6,20 @@
 Build-Depends: debhelper (>= 9), dh-autoreconf,
   flex,
   libedit-dev, zlib1g-dev,
-  llvm-8-dev, libclang-8-dev,
-  clang-8, clang-format-8,
+  llvm-9-dev, libclang-9-dev,
+  clang-9, clang-format-9,
   libbenchmark-timer-perl,
   libfile-which-perl, libregexp-common-perl, libexporter-lite-perl,
   libgetopt-tabular-perl, libterm-readkey-perl,
-# for running the tests:
-  frama-c-base
+  frama-c-base <!nocheck>
 Build-Conflicts: kcc
-Standards-Version: 4.3.0
+Standards-Version: 4.4.1
 Homepage: http://embed.cs.utah.edu/creduce/
 
 Package: creduce
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends},
-  clang-format-8,
+  clang-format-9,
   libbenchmark-timer-perl,
   libfile-which-perl, libregexp-common-perl, libexporter-lite-perl,
   libgetopt-tabular-perl, libterm-readkey-perl,

=== debian/rules ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
 
-CLANG_V	= 8
+CLANG_V	= 9
 CLANG	= clang-$(CLANG_V)
 GCC	= gcc
 
@@ -34,7 +34,11 @@
 # these are time consuming ...
 ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
   ifeq (,$(filter $(DEB_HOST_ARCH),m68k sh4 s390 sparc))
-	cd tests && CLANG="$(CLANG)" GCC="$(GCC)" ./run_tests
+	if grep -q '^  *frama-c-base' debian/control; then \
+	  cd tests && CLANG="$(CLANG)" GCC="$(GCC)" ./run_tests; \
+	else \
+	  echo "Cannot run the tests, frama-c-base not in build dependencies."; \
+	fi
   endif
 endif
